FilterLeafReader.FilterTermsEnum (Lucene 10.5.1 core API)
Description: declaration: package: org.apache.lucene.index, class: FilterLeafReader, class: FilterTermsEnum

Package org.apache.lucene.index

# Class FilterLeafReader.FilterTermsEnum

java.lang.Object
org.apache.lucene.index.TermsEnum
org.apache.lucene.index.FilterLeafReader.FilterTermsEnum

All Implemented Interfaces:
  `BytesRefIterator`

Direct Known Subclasses:
  `ExitableDirectoryReader.ExitableTermsEnum`

Enclosing class:
  `FilterLeafReader`

public abstract static class FilterLeafReader.FilterTermsEnum extends TermsEnum
Base class for filtering `TermsEnum` implementations.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.lucene.index.TermsEnum

  `TermsEnum.SeekStatus`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected final TermsEnum`
  `in`
  The underlying TermsEnum instance.

  ### Fields inherited from class org.apache.lucene.index.TermsEnum

  `EMPTY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `FilterTermsEnum(TermsEnum in)`
  Creates a new FilterTermsEnum

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AttributeSource`
  `attributes()`
  Returns the related attributes.
  `int`
  `docFreq()`
  Returns the number of documents containing the current term.
  `ImpactsEnum`
  `impacts(int flags)`
  Return a `ImpactsEnum`.
  `BytesRef`
  `next()`
  Increments the iteration to the next `BytesRef` in the iterator.
  `long`
  `ord()`
  Returns ordinal position for current term.
  `PostingsEnum`
  `postings(PostingsEnum reuse, int flags)`
  Get `PostingsEnum` for the current term, with control over whether freqs, positions, offsets or payloads are required.
  `IOBooleanSupplier`
  `prepareSeekExact(BytesRef text)`
  Two-phase `TermsEnum.seekExact(org.apache.lucene.util.BytesRef)`.
  `TermsEnum.SeekStatus`
  `seekCeil(BytesRef text)`
  Seeks to the specified term, if it exists, or to the next (ceiling) term.
  `void`
  `seekExact(long ord)`
  Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`.
  `boolean`
  `seekExact(BytesRef text)`
  Attempts to seek to the exact term, returning true if the term is found.
  `void`
  `seekExact(BytesRef term, TermState state)`
  Expert: Seeks a specific position by `TermState` previously obtained from `TermsEnum.termState()`.
  `BytesRef`
  `term()`
  Returns current term.
  `TermState`
  `termState()`
  Expert: Returns the TermsEnums internal state to position the TermsEnum without re-seeking the term dictionary.
  `long`
  `totalTermFreq()`
  Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term).

  ### Methods inherited from class org.apache.lucene.index.TermsEnum

  `postings, preferSeekExact`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### in

    protected final TermsEnum in
    The underlying TermsEnum instance.

- ## Constructor Details

  - ### FilterTermsEnum

    protected FilterTermsEnum(TermsEnum in)
    Creates a new FilterTermsEnum
    Parameters:
      `in` - the underlying TermsEnum instance.

- ## Method Details

  - ### attributes

    public AttributeSource attributes()
    Description copied from class: `TermsEnum`
    Returns the related attributes.
    Specified by:
      `attributes` in class `TermsEnum`

  - ### seekCeil

    public TermsEnum.SeekStatus seekCeil(BytesRef text) throws IOException
    Description copied from class: `TermsEnum`
    Seeks to the specified term, if it exists, or to the next (ceiling) term. Returns SeekStatus to indicate whether exact term was found, a different term was found, or EOF was hit. The target term may be before or after the current term. If this returns SeekStatus.END, the enum is unpositioned.
    Specified by:
      `seekCeil` in class `TermsEnum`
    Throws:
      `IOException`

  - ### seekExact

    public boolean seekExact(BytesRef text) throws IOException
    Description copied from class: `TermsEnum`
    Attempts to seek to the exact term, returning true if the term is found. If this returns false, the enum is unpositioned. For some codecs, seekExact may be substantially faster than `TermsEnum.seekCeil(org.apache.lucene.util.BytesRef)`.
    Specified by:
      `seekExact` in class `TermsEnum`
    Returns:
      true if the term is found; return false if the enum is unpositioned.
    Throws:
      `IOException`

  - ### seekExact

    public void seekExact(long ord) throws IOException
    Description copied from class: `TermsEnum`
    Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`. The target ord may be before or after the current ord, and must be within bounds.
    Specified by:
      `seekExact` in class `TermsEnum`
    Throws:
      `IOException`

  - ### next

    public BytesRef next() throws IOException
    Description copied from interface: `BytesRefIterator`
    Increments the iteration to the next `BytesRef` in the iterator. Returns the resulting `BytesRef` or `null` if the end of the iterator is reached. The returned BytesRef may be re-used across calls to next. After this method returns null, do not call it again: the results are undefined.
    Returns:
      the next `BytesRef` in the iterator or `null` if the end of the iterator is reached.
    Throws:
      `IOException` - If there is a low-level I/O error.

  - ### term

    public BytesRef term() throws IOException
    Description copied from class: `TermsEnum`
    Returns current term. Do not call this when the enum is unpositioned.
    Specified by:
      `term` in class `TermsEnum`
    Throws:
      `IOException`

  - ### ord

    public long ord() throws IOException
    Description copied from class: `TermsEnum`
    Returns ordinal position for current term. This is an optional method (the codec may throw `UnsupportedOperationException`). Do not call this when the enum is unpositioned.
    Specified by:
      `ord` in class `TermsEnum`
    Throws:
      `IOException`

  - ### docFreq

    public int docFreq() throws IOException
    Description copied from class: `TermsEnum`
    Returns the number of documents containing the current term. Do not call this when the enum is unpositioned. `TermsEnum.SeekStatus.END`.
    Specified by:
      `docFreq` in class `TermsEnum`
    Throws:
      `IOException`

  - ### totalTermFreq

    public long totalTermFreq() throws IOException
    Description copied from class: `TermsEnum`
    Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term). Note that, like other term measures, this measure does not take deleted documents into account.
    Specified by:
      `totalTermFreq` in class `TermsEnum`
    Throws:
      `IOException`

  - ### postings

    public PostingsEnum postings(PostingsEnum reuse, int flags) throws IOException
    Description copied from class: `TermsEnum`
    Get `PostingsEnum` for the current term, with control over whether freqs, positions, offsets or payloads are required. Do not call this when the enum is unpositioned. This method will not return null.

    NOTE: the returned iterator may return deleted documents, so deleted documents have to be checked on top of the `PostingsEnum`.

    Specified by:
      `postings` in class `TermsEnum`
    Parameters:
      `reuse` - pass a prior PostingsEnum for possible reuse
      `flags` - specifies which optional per-document values you require; see `PostingsEnum.FREQS`
    Throws:
      `IOException`

  - ### impacts

    public ImpactsEnum impacts(int flags) throws IOException
    Description copied from class: `TermsEnum`
    Return a `ImpactsEnum`.
    Specified by:
      `impacts` in class `TermsEnum`
    Throws:
      `IOException`
    See Also:
      - `TermsEnum.postings(PostingsEnum, int)`

  - ### seekExact

    public void seekExact(BytesRef term, TermState state) throws IOException
    Description copied from class: `TermsEnum`
    Expert: Seeks a specific position by `TermState` previously obtained from `TermsEnum.termState()`. Callers should maintain the `TermState` to use this method. Low-level implementations may position the TermsEnum without re-seeking the term dictionary.

    Seeking by `TermState` should only be used iff the state was obtained from the same `TermsEnum` instance.

    NOTE: Using this method with an incompatible `TermState` might leave this `TermsEnum` in undefined state. On a segment level `TermState` instances are compatible only iff the source and the target `TermsEnum` operate on the same field. If operating on segment level, TermState instances must not be used across segments.

    NOTE: A seek by `TermState` might not restore the `AttributeSource`'s state. `AttributeSource` states must be maintained separately if this method is used.

    Specified by:
      `seekExact` in class `TermsEnum`
    Parameters:
      `term` - the term the TermState corresponds to
      `state` - the `TermState`
    Throws:
      `IOException`

  - ### prepareSeekExact

    public IOBooleanSupplier prepareSeekExact(BytesRef text) throws IOException
    Description copied from class: `TermsEnum`
    Two-phase `TermsEnum.seekExact(org.apache.lucene.util.BytesRef)`. The first phase typically calls `IndexInput.prefetch(long, long)` on the right range of bytes under the hood, while the second phase `IOBooleanSupplier.get()` actually seeks the term within these bytes. This can be used to parallelize I/O across multiple terms by calling `TermsEnum.prepareSeekExact(org.apache.lucene.util.BytesRef)` on multiple terms enums before calling `IOBooleanSupplier.get()`.

    NOTE: It is illegal to call other methods on this `TermsEnum` after calling this method until `IOBooleanSupplier.get()` is called.

    NOTE: This may return `null` if this `TermsEnum` can identify that the term may not exist without performing any I/O.

    NOTE: The returned `IOBooleanSupplier` must be consumed in the same thread.

    Specified by:
      `prepareSeekExact` in class `TermsEnum`
    Throws:
      `IOException`

  - ### termState

    public TermState termState() throws IOException
    Description copied from class: `TermsEnum`
    Expert: Returns the TermsEnums internal state to position the TermsEnum without re-seeking the term dictionary.

    NOTE: A seek by `TermState` might not capture the `AttributeSource`'s state. Callers must maintain the `AttributeSource` states separately

    Specified by:
      `termState` in class `TermsEnum`
    Throws:
      `IOException`
    See Also:
      - `TermState`
      - `TermsEnum.seekExact(BytesRef, TermState)`